(function () {
    "use strict";

    angular.module('core').controller('notaFiscalDetailController', controller);
    controller.$inject = ['$scope', '$q', '$state', '$stateParams', '$alert', 'notaFiscalService', 'arquivoService'];

    function controller($scope, $q, $state, $stateParams, $alert, notaFiscalService, arquivoService) {
        $scope.initializeLayout('Nota Fiscal');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false
        };
        $scope.popups = {
            item: {
                index: -1,
                selected: null,
                select: function (index) {
                    $scope.popups.item.index = index;
                    $scope.popups.item.selected = $scope.state.item.Itens[index];
                },
                unselect: function () {
                    $scope.popups.item.index = -1;
                    $scope.popups.item.selected = null;
                },
                next: function () {
                    if ($scope.popups.item.index < ($scope.state.item.Itens.length - 1)) {
                        $scope.popups.item.index++;
                        $scope.popups.item.selected = $scope.state.item.Itens[$scope.popups.item.index];
                    }
                },
                prior: function () {
                    if ($scope.popups.item.index > 0) {
                        $scope.popups.item.index--;
                        $scope.popups.item.selected = $scope.state.item.Itens[$scope.popups.item.index];
                    }
                },
            },
            cancelamento: {
                ativo: false,
                processando: false,
                toggle: async () => {
                    $scope.popups.cancelamento.ativo = !$scope.popups.cancelamento.ativo;
                },
                run: async () => {
                    try {
                        if ($scope.popups.cancelamento.processando)
                            return;

                        $scope.popups.cancelamento.processando = true;

                            const response = await notaFiscalService.enviarCancelamentoSefaz($scope.state.item);

                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.state.item = response.Data;
                        }

                        $scope.popups.cancelamento.toggle();
                    } catch (error) {
                        $scope.tools.toastr.error("Não foi possível acessar o(s) servidor(es)");
                        console.error(error);
                    } finally {
                        $scope.popups.cancelamento.processando = false;
                        $scope.$digest();
                    }
                }
            },
            inutilizacao: {
                ativo: false,
                processando: false,
                toggle: async () => {
                    $scope.popups.inutilizacao.ativo = !$scope.popups.inutilizacao.ativo;
                },
                run: async () => {
                    try {
                        if ($scope.popups.inutilizacao.processando)
                            return;

                        $scope.popups.inutilizacao.processando = true;

                        const response = await notaFiscalService.enviarInutilizacaoSefaz($scope.state.item);

                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.state.item = response.Data;
                        }

                        $scope.popups.inutilizacao.toggle();
                    } catch (error) {
                        $scope.tools.toastr.error("Não foi possível acessar o(s) servidor(es)");
                        console.error(error);
                    } finally {
                        $scope.popups.inutilizacao.processando = false;
                        $scope.$digest();
                    }
                }
            },
            consulta: {
                ativo: false,
                processando: false,
                toggle: async () => {
                    $scope.popups.inutilizacao.ativo = !$scope.popups.inutilizacao.ativo;
                },
                run: async () => {
                    try {
                        if ($scope.popups.consulta.processando)
                            return;

                        $scope.popups.consulta.processando = true;

                        const response = await notaFiscalService.enviarConsultaSefaz($scope.state.item);

                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.state.item = response.Data;
                        }

                    } catch (error) {
                        $scope.tools.toastr.error("Não foi possível acessar o(s) servidor(es)");
                        console.error(error);
                    } finally {
                        $scope.popups.consulta.processando = false;
                        $scope.$digest();
                    }
                }
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.reenviarNota = async () => {
            try {
                debugger
                if ($scope.state.carregando == true)
                    return;

                $scope.state.carregando = true;

                const response = await notaFiscalService.reenviarEmissaoSefaz($scope.state.item);

                if (response.Status < 0) {
                    $alert({ text: response.Message, title: $scope.Title });
                } else {
                    $scope.state.item = response.Data;
                }
                 
            } catch (error) {
                $scope.tools.toastr.error("Não foi possível acessar o(s) servidor(es)");
                console.error(error);
            } finally {
                $scope.state.carregando = false;
                $scope.$digest();
            }
        }

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            notaFiscalService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.downloadAllXml = async () => {
            try {
                if ($scope.state.downloading)
                    return;

                $scope.state.downloading = true;

                const args = { filtro: { ID: $scope.state.item.ID } };
                const response = await notaFiscalService.downloadAllXml(args)

                if (!response.data.byteLength) {
                    $alert({ text: "Não foram encontrados XMLs para essa nota." });
                } else {
                    var blob = new Blob([response.data], { type: response.headers("content-type") });
                    var fileName = response.headers("content-disposition").toLowerCase().replace("attachment; filename=", "");

                    if (navigator.msSaveOrOpenBlob) {
                        navigator.msSaveOrOpenBlob(blob, fileName);
                    } else {
                        const a = document.createElement("a");
                        const url = window.URL.createObjectURL(blob);

                        document.body.appendChild(a);
                        a.href = url;
                        a.download = fileName;
                        a.style = "display:none";
                        a.click();

                        window.URL.revokeObjectURL(url);
                        a.remove();
                    }
                }
            } catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(error);
            } finally {
                $scope.state.downloading = false;
                $scope.$digest();
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();